#include <new>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "FullDuplexSerialPlus.h"
#include "VMCog.h"

// Create a full duplex UART
//FullDuplexSerialPlus uart(31, 30, 0, baud);

// Create a virtual memory driver
int mailbox[4] = {0,0,0,0};
VMCog vm;

void print(FullDuplexSerialPlus* uart, char *s)
{
   while(*s != 0)
   {
     uart->tx((int)*s++);
   }
}

int main(int argc, char* argv[])
{
    int baud = 115200;

    char* msg = "\nPASM Firmware in C++ test.\n";
    
    // Get some heap for FDS
    char* m = (char*)malloc(sizeof(FullDuplexSerialPlus));    

    // Construct an FDS in that heap space, we do this because "new" is not working yet.
    FullDuplexSerialPlus* uart = new (m) FullDuplexSerialPlus(31, 30, 0, baud);

    print(uart, msg);

    print(uart, "Starting VMCog...\n");
    vm.start(mailbox, 0x7C00, 2);
    print(uart, "OK\n");
    
    char data;
    char gotThis;
    int address = 0;
    while (1)
    {
        print(uart, "Press any key to continue\n");
        data = uart->rx();
        uart->tx((int)data);
        uart->tx((int)'\n');
  
        print(uart, "Writing to VMCog...\n");
        vm.wrvbyte(address, data);
        print(uart, "OK\n");
    
        print(uart, "Reading from VMCog...\n");
        gotThis = vm.rdvbyte(address++);
        print(uart, "Got ");
        uart->tx((int)gotThis);
        print(uart, "\nOK\n");
    }

    // Explicit destructor invocation, don't use delete
    uart->~FullDuplexSerialPlus();
    free (m);
    return(0);
}
